
/**
 * This is the second application used in the Java-GNOME tutorial.
 * It demonstrates the use of callbacks and events.  It also
 * introduces the user to menus.
 */

import gtk.*;
import gnome.*;

public class Second {
    private GnomeApp app = null;
    public static final String appVersion = "0.1";

    /**
     * Insert the method's description here.
     * Creation date: (10/26/00 %r)
     */
    public Second() {
	createMainWindow();
	createMenus();
    }

    /**
     * Insert the method's description here.
     * Creation date: (10/26/00 %r)
     */
    private void createMainWindow() {
	app = new GnomeApp("Second", "Second App");
	app.setPolicy(false, true, false);
	app.setWmclass("Second", "SecondApp");
	app.setUsize(200, 200);
	app.signal_connect("delete_event", this);
	app.signal_connect("destroy", this);
	app.show();
    }

    /**
     * Insert the method's description here.
     * Creation date: (10/26/00 %r)
     */
    private void createMenus() {
	GtkMenuBar menubar = new GtkMenuBar();
	GtkMenuItem file = new GtkMenuItem("File");
	GtkMenuItem help = new GtkMenuItem("Help");
	menubar.append(file);
	menubar.append(help);
	
	// finish the file menu
	GtkMenu fileMenu = new GtkMenu();
	GtkMenuItem fileExit = new GtkMenuItem("Exit");
	fileExit.signal_connect("activate", "fileExit", this);
	file.setSubmenu(fileMenu);
	fileMenu.append(fileExit);
	// now display it
	fileExit.show();
	file.show();
	
	// finish the help menu
	GtkMenu helpMenu = new GtkMenu();
	GtkMenuItem helpAbout = new GtkMenuItem("About");
	helpAbout.signal_connect("activate", "helpAbout", this);
	help.setSubmenu(helpMenu);
	helpMenu.append(helpAbout);
	// display
	helpAbout.show();
	help.show();
	
	menubar.show();
	
	app.setMenus(menubar);
    }

    /**
     * Insert the method's description here.
     * Creation date: (10/26/00 %r)
     * @return boolean
     * @param value int
     */
    public boolean delete_event(int value) {
	return true;
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (10/26/00 %r)
     */
    public void destroy() {
	Gtk.mainQuit();
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (10/26/00 %r)
     */
    public void fileExit() {
	Gtk.mainQuit();
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (10/26/00 %r)
     */
    public void helpAbout() {
	String title = "Second App";
	String version = "Version " + appVersion;
	String license = "GPL";
	String[] authors = {"The Java-GNOME team"};
	String comments = "This example is a part of the Java-GNOME tutorial";
	String pixmap = "gftp.png";
	GnomeAbout about = new GnomeAbout(title, version, license,
					  authors, comments, pixmap);
	about.show();
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (10/26/00 %r)
     * @param args java.lang.String[]
     */
    public static void main(String[] args) {
	Gnome.init("Second", Second.appVersion, 0, 0);
	Second second = new Second();
	Gtk.main();
    }    
}
